/*
  GO-WARP: a Time Warp simulator written in Go
  http://pads.cs.unibo.it 
 
  This file is part of GO-WARP.  GO-WARP is free software: you can
  redistribute it and/or modify it under the terms of the GNU General Public
  License as published by the Free Software Foundation, version 2.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

  Copyright 2012, Pietro Ansaloni, Gabriele D'Angelo, Moreno Marzolla
  Computer Science Department, University of Bologna, Italy
*/

package Shared

import(
    "fmt"
    "time"
    "./DT"
    "./Local"
    "./Const"
)

var(
    Lpnum int
    N_gvt int
    State []int8
    N_rollback []int
    EventManager func(ev *DT.Event, l *Local.LocalData)
    EndTime DT.Time

    StartTime int64
)


func Setup(lpn int, simt DT.Time, f func(ev *DT.Event, l *Local.LocalData)) {
    Lpnum = lpn
    EndTime = simt
    N_gvt = 0
    State = make([]int8, lpn)
    N_rollback = make([]int, lpn)
    for i:=0;i<lpn;i++ {
        State[i] = Const.LPNOTSTART
        N_rollback[i] = 0
    }
    EventManager = f

    fmt.Println("SETUP COMPLETED: lpn =",Lpnum,"EndTime =",EndTime)
    StartTime = time.Nanoseconds()
}
