/*
  GO-WARP: a Time Warp simulator written in Go
  http://pads.cs.unibo.it
  
  This file is part of GO-WARP.  GO-WARP is free software: you can
  redistribute it and/or modify it under the terms of the GNU General Public
  License as published by the Free Software Foundation, version 2.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

  Copyright 2012, Pietro Ansaloni, Gabriele D'Angelo, Moreno Marzolla
  Computer Science Department, University of Bologna, Italy
*/

package State

import(
    "./DT"
)

type State struct {
    SimTime DT.Time
    LpVar DT.LPstate
}


func CreateState(time DT.Time, lpvar DT.LPstate) *State {
    var state *State = new(State)

    *state = State{time,lpvar}
    return state
}


/* type State implements the DT.Element interface */
func (st State) GetTime() DT.Time {
    return st.SimTime
}


func (st State) IsEqual(e DT.Elem) bool {
    ret := false
    st1 := e.(State)
    if st.SimTime==st1.SimTime {
        ret = true
    }
    return ret
}
