#
# This file is part of GO-WARP.  GO-WARP is free software: you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Copyright 2012, Pietro Ansaloni, Gabriele D'Angelo, Moreno Marzolla
# Computer Science Department, University of Bologna, Italy
#

if [ $# -lt 3 ]
then
  echo "test-main: WRONG NUMBER OF PARAMETERS"
  echo "usage: ./testmain.sh #LPs #entities #repetitions"
  exit 1
fi

LPS=$1
ENTITIES=$2
REPETITIONS=$3

out="logs/out.$LPS-$ENTITIES"

# as many runs as the number of repetitions
k=0
while [ $k -lt $REPETITIONS ]
do
  k=$((k+1))
  echo "--- REPETITION NUMBER: $k ----------------------------------" >> $out
  # simulator execution
  ./builds/Main.out $LPS $ENTITIES >> $out 2>&1
done

# counting the runs that have correctly reached the Wall Clock Time
echo -n "Simulation OK: "
grep "Wall Clock Time" $out | wc -l

# some statistics on the runs
./statistics.sh $out

# log cleaning
make cleanlog
echo
