#
# This file is part of GO-WARP.  GO-WARP is free software: you can
# redistribute it and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Copyright 2012, Pietro Ansaloni, Gabriele D'Angelo, Moreno Marzolla
# Computer Science Department, University of Bologna, Italy
#

#!/bin/bash
if [ $# -lt 2 ]
then
    echo "test-scalability: WRONG NUMBER OF PARAMETERS"
    echo "usage: ./test-scalability.sh #entities #repetitions"
    exit
fi

ENTITIES=$1
REPETITIONS=$2

rm -f logs/*

# number of cores used
for GOMAX in 1 2 3 4
do
	# number of LPs
	for LP in 1 2 3 4
	do
		# it is really a nonsense to simulate many LPs on the same CPU core
		if [ $LP -le $GOMAX ]
		then
		  echo "LP: $LP, GOMAXPROCS = $GOMAX"
		  export GOMAXPROCS=$GOMAX; ./test-main.sh $LP $ENTITIES $REPETITIONS
		fi
	done
	
	sleep 3
done
